/****************************************************************************/
/** virtsample.cpp                                                         **/
/** ---------------------------------------------------------------------- **/
/** Shows how to virtualize old style callback scheme                      **/
/** ---------------------------------------------------------------------- **/
/** ---------------------------------------------------------------------- **/
/** December 30, 1998 by Oleg Kagan                                        **/
/****************************************************************************/

//============================================================================
#include <iostream.h>
#pragma hdrstop

//============================================================================
#include "vscbscheme.h"
#include "vsprogress.h"

// Old style sample
//============================================================================
void OldStyleProgress1(

	int i

){
	cout << i << "\tOldStyleProgress1\n";
} /*OldStyleProgress1(int)*/

//----------------------------------------------------------------------------
void OldStyleProgress2(

	int i

){
	cout << 2 * i << "\tOldStyleProgress2\n";
} /*OldStyleProgress2(int)*/

//----------------------------------------------------------------------------
void OldStyle()
{
	ProcessScheme(OldStyleProgress1); cout << endl;
	ProcessScheme(OldStyleProgress2); cout << endl;
} /*OldStyle()*/

// New style sample
//============================================================================
class TNewStyleProgress : public TProgressProcessor {
public:
	//------------------------------------------------------------------------
	TNewStyleProgress(int iInitFactor, const char* c_szInitText) : 
		iFactor(iInitFactor), c_szText(c_szInitText) 
	{} /*TNewStyleProgress(int, const char*)*/

	//------------------------------------------------------------------------
	void operator()(int i) 
	{
		cout << i * iFactor;
		if (c_szText) cout << "\t" << c_szText << endl;
	} /*operator()(int)*/
private:
	//------------------------------------------------------------------------
	int iFactor;
	const char* c_szText;
} /*TNewStyleProgress*/;

//----------------------------------------------------------------------------
void NewStyle()
{
	TNewStyleProgress Progress1(1, "NewStyleProgress1");
	TNewStyleProgress Progress2(2, "NewStyleProgress2");

	ProcessScheme(Progress1);
	cout << endl;
	ProcessScheme(Progress2);
} /*NewStyle()*/

//============================================================================
int main(

	int /*argc*/,
	char* /*argv*/[]

){
	OldStyle();
	cout.flush();
	NewStyle();
	cout.flush();
	return 0;
} /*main()*/




