/****************************************************************************/
/** vsprogress.cpp                                                         **/
/** ---------------------------------------------------------------------- **/
/** Virutualizes old style scheme                                          **/
/** ---------------------------------------------------------------------- **/
/** ---------------------------------------------------------------------- **/
/** December 30, 1998 by Oleg Kagan                                        **/
/****************************************************************************/

//============================================================================
#include <memory.h>
#include <stdlib.h>

//============================================================================
#include "vsprogress.h"

//============================================================================
#define VSPROGRESS_DEFAULT_ADDRESS 0x77777777

//============================================================================
void CallBackOrg(int);
void CallBackEnd();

//----------------------------------------------------------------------------
void* VirtualizerPrepareCode(

	void* p_fnStart,
	void* p_fnEnd,
	void* pOrgValue,
	void* pNewValue

){
	size_t nCodeSize = (char*)p_fnEnd - (char*)p_fnStart;
	void* pCode = malloc(nCodeSize + 1);

	if (pCode) {
		memcpy(pCode, p_fnStart, nCodeSize);

		char* p_cSearch = (char*)pCode;
		char* p_cEnd = (char*)pCode + nCodeSize - sizeof(void*);

		while ((p_cSearch <= p_cEnd) && (*(void**)p_cSearch != pOrgValue)) 
			++p_cSearch;

		if (p_cSearch <= p_cEnd) *(void**)p_cSearch = pNewValue;
		else {free(pCode); pCode = 0;}
	} /*if*/

	return pCode;
} /*VirtualizerPrepareCode(void*, void*, void*, void*)*/

// TProgressProcessor implementation
//============================================================================
TProgressProcessor::~TProgressProcessor()
{
	if (p_fnCallback) {free(p_fnCallback); p_fnCallback = 0;}
} /*~TProgressProcessor()*/

//----------------------------------------------------------------------------
TProgressCallbackPtr TProgressProcessor::Callback()
{
	if (!p_fnCallback) {
		p_fnCallback = (TProgressCallbackPtr)VirtualizerPrepareCode(
			CallBackOrg, CallBackEnd, 
			(void*)VSPROGRESS_DEFAULT_ADDRESS, this
		) /*VirtualizerPrepareCode*/;
	} /*if*/

	return p_fnCallback;
} /*TProgressProcessor::Callback()*/

//============================================================================
void CallBackOrg(

	int i
	
){
	TProgressProcessor* volatile pProcessor;

	pProcessor = (TProgressProcessor*)VSPROGRESS_DEFAULT_ADDRESS;
//or 
//	_asm {mov pProcessor, VSPROGRESS_DEFAULT_ADDRESS}

	(*pProcessor)(i);
} /*CallbackOrg(int)*/

//----------------------------------------------------------------------------
void CallBackEnd() {}